#region Copyright Syncfusion Inc. 2001 -2004
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////// 
//  Copyright Syncfusion Inc. All rights reserved. Use of this code is subject to the terms of our 
//  license. A copy of the current license can be obtained at any time by e-mailing licensing@syncfusion.com. 
//  Re-distribution in any form is strictly prohibited. Any infringement will be prosecuted under applicable laws. 
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////// 
#endregion 
 


namespace VirtualGrid
{
	using System;
	using System.Drawing;
	using System.Collections;
	using System.ComponentModel;
	using System.Windows.Forms;
	using System.Data;

	using Syncfusion.Windows.Forms.Grid;
	using Syncfusion.Windows.Forms;
	using Syncfusion.Drawing;
	
	
	
	
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private Syncfusion.Windows.Forms.Grid.GridControl gridControl1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			InitializeComponent();

			gridControl1.ControllerOptions = GridControllerOptions.All & (~GridControllerOptions.OleDataSource);
    		gridControl1.Model.DataProvider=new QueryGridNormal(gridControl1);
			gridControl1.ResetVolatileData();

		}


		

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.gridControl1 = new Syncfusion.Windows.Forms.Grid.GridControl();
			((System.ComponentModel.ISupportInitialize)(this.gridControl1)).BeginInit();
			this.SuspendLayout();
			// 
			// gridControl1
			// 
			this.gridControl1.Anchor = (((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.gridControl1.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.gridControl1.Bounds = new System.Drawing.Rectangle(24, 24, 504, 320);
			this.gridControl1.ColCount = 55;
			this.gridControl1.DefaultColWidth = 65;
			this.gridControl1.DefaultGridBorderStyle = Syncfusion.Windows.Forms.Grid.GridBorderStyle.Dotted;
			this.gridControl1.DefaultRowHeight = 17;
			this.gridControl1.Dock = System.Windows.Forms.DockStyle.None;
			this.gridControl1.HorizontalThumbTrack = true;
			this.gridControl1.Location = new System.Drawing.Point(24, 24);
			this.gridControl1.Name = "gridControl1";
			this.gridControl1.RowCount = 100;
			this.gridControl1.Size = new System.Drawing.Size(504, 320);
			this.gridControl1.TabIndex = 1;
			this.gridControl1.Text = "gridControl1";
			this.gridControl1.ThemesEnabled = true;
			this.gridControl1.VerticalThumbTrack = true;
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(560, 374);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.gridControl1});
			this.Name = "Form1";
			this.Text = "Form1";
			((System.ComponentModel.ISupportInitialize)(this.gridControl1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		public static void Main() 
		{
			Application.Run(new Form1());
		}

		
	}
	

	public class QueryGridNormal:IGridModelDataProvider
	{ 

		#region  -----------------------   VARS ---------------------------------
           
	
		private GridControl Grid;
		private DataTable table;
     
	
		#endregion

		#region  --------------    CONSTRUCTION -----------------------
	
		public QueryGridNormal(GridControl  pgrid):base()
		{
			Grid=pgrid;
			Grid.Model.Cols.HeaderCount=0;
			Grid.Model.Options.DefaultGridBorderStyle=GridBorderStyle.Solid;
			
			Grid.Model.Options.NumberedColHeaders=false;
			Grid.Model.Options.NumberedRowHeaders=false;
			Grid.Model.Options.AlphaBlendSelectionColor=System.Drawing.Color.SteelBlue;

			Grid.Model.CommandStack.Enabled = true;
			table = GetTable();
		}

	
		#endregion

		#region  -------------- GETTABLE -----------------------
		DataTable GetTable()
		{
			int nCols = 15;
			int nRows = 2000;
			
			DataTable dt = new DataTable();
			
			for(int i = 0 ;i < nCols ;i++)
			  dt.Columns.Add(string.Format("col{0}",i));  
			
			for(int i = 1;i <= nRows;i++)
			{
				DataRow dr = dt.NewRow();
				for(int j = 0 ;j < nCols ;j++)
					dr[j] = string.Format("col{0} row{1}",j,i); 
				dt.Rows.Add(dr);
			}
			return dt;
		}
		#endregion

		#region  --------------    IGridModelDataProvider   MEMBERS --------------------
		public   void  QueryCellInfo(Syncfusion.Windows.Forms.Grid.GridQueryCellInfoEventArgs e)
		{ 
			int eRowIndex=e.RowIndex-1;
			int eColIndex=e.ColIndex-1;
			if(!Grid.Visible )
			{
				e.Handled = true;
				return;
			}
			if( e.RowIndex >0 && e.ColIndex  > 0)
			{
				e.Style.CellValue= table.Rows[e.RowIndex -1 ][e.ColIndex -1] ;
				e.Handled = true;
				return;  
			}
			else if(e.RowIndex == 0 && e.ColIndex > 0)
			{
				e.Style.CellValue= table.Columns[e.ColIndex -1 ].ColumnName;
				e.Handled = true;
				return; 
			}
		}

	
		
		public 	void SaveCellInfo( Syncfusion.Windows.Forms.Grid.GridSaveCellInfoEventArgs e)
		{
			int eRowIndex=e.RowIndex-1;
			int eColIndex=e.ColIndex-1;
			if(!Grid.Visible )
			{
				e.Handled = true;
				return;
			}
			if( e.RowIndex >0 && e.ColIndex  > 0)
			{
				table.Rows[e.RowIndex - 1][e.ColIndex - 1] = e.Style.CellValue ;
				e.Handled = true;
				return;  
			}
		}

		public	 void QueryColCount( GridRowColCountEventArgs e)
		{
			e.Count = table.Columns.Count;
			e.Handled = true;
		}



		public  void  QueryRowCount(GridRowColCountEventArgs e)
		{
			e.Count=table.Rows.Count; 
			e.Handled = true;
			return;
		}   
    
		public   int NameToColIndex(string s)
		{ 
			return Grid.Model.NameToColIndex(s);
		}
     
		public  int NameToRowIndex(string s)
		{ 
			return Grid.Model.NameToRowIndex(s);
		}


		#endregion

	}
	






}
